/**
 * This tool fixes MPTS Configure error that looks like a deadlock.
 * (C) Sergey Posokhov, 2006, U Tumer Mari El - Krasnogorsk Russia.
 * Intended for eComStation 1.x and Nice Enhancer. * GNU GPL *
 */

#define INCL_KBD
#define INCL_DOSMISC
#define INCL_DOSPROCESS
#define INCL_DOSERRORS

#include <OS2.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

BYTE Binary_data[ 65536 ];

//  ࠢ 䠩 ஥ MPTS 

VOID main( VOID )
{
 // ॡࠥ ன⢠  "C:"  "Z:"  ஡㥬  䠩 "IBMLVL.INI".
 for( BYTE Drive_letter = 'C'; Drive_letter <= 'Z'; Drive_letter ++ )
  {
   {
    // ஢塞 ⢮ 䠩 MPTS.
    CHAR File_name[] = "#:\\IBMCOM\\MPTS.exe"; File_name[ 0 ] = Drive_letter;
    FILESTATUS3 Attributes; memset( &Attributes, 0, sizeof( Attributes ) );
    APIRET RC = DosQueryPathInfo( File_name, FIL_STANDARD, &Attributes, sizeof( Attributes ) );

    // ᫨ 䠩  - த ॡ.
    if( RC != NO_ERROR ) continue;
   }

   // ஢塞 ⢮ 䠩 ஥.
   CHAR File_name[] = "#:\\IBMLVL.INI"; File_name[ 0 ] = Drive_letter;
   FILESTATUS3 Attributes; memset( &Attributes, 0, sizeof( Attributes ) );
   APIRET RC = DosQueryPathInfo( File_name, FIL_STANDARD, &Attributes, sizeof( Attributes ) );

   // ᫨ 䠩  - த ॡ.
   if( RC != NO_ERROR ) continue;

   //  䠩 .
   Attributes.attrFile = FILE_NORMAL;
   DosSetPathInfo( File_name, FIL_STANDARD, &Attributes, sizeof( Attributes ), 0 );

   // ஡㥬  䠩.
   ULONG Action = OPEN_ACTION_OPEN_IF_EXISTS;
   ULONG Mode = OPEN_FLAGS_FAIL_ON_ERROR | OPEN_SHARE_DENYWRITE | OPEN_ACCESS_READWRITE;

   HFILE File = NULLHANDLE; ULONG Report = 0;
   RC = DosOpen( File_name, &File, &Report, 0, FILE_NORMAL, Action, Mode, NULL );

   // ᫨ 䠩    - த ॡ.
   if( RC != NO_ERROR ) continue;

   // ⠥ ᮤন 䠩.
   ULONG Length = 0; memset( Binary_data, 0, sizeof( Binary_data ) );
   DosRead( File, Binary_data, sizeof( Binary_data ), &Length );

   // ஡㥬    ப "\I\IBMCOM"  塞   "D:\IBMCOM".
   BYTE Path_is_fixed = 0;

   for( INT Position = 0; Position < Length; Position ++ )
    {
     if( Binary_data[ Position + 0 ] == '\\' &&
         Binary_data[ Position + 1 ] == 'I'  &&
         Binary_data[ Position + 2 ] == '\\' &&
         Binary_data[ Position + 3 ] == 'I'  &&
         Binary_data[ Position + 4 ] == 'B'  &&
         Binary_data[ Position + 5 ] == 'M'  &&
         Binary_data[ Position + 6 ] == 'C'  &&
         Binary_data[ Position + 7 ] == 'O'  &&
         Binary_data[ Position + 8 ] == 'M'  )
      {
       Binary_data[ Position + 0 ] = Drive_letter;
       Binary_data[ Position + 1 ] = ':';
       Binary_data[ Position + 2 ] = '\\';
       Binary_data[ Position + 3 ] = 'I';
       Binary_data[ Position + 4 ] = 'B';
       Binary_data[ Position + 5 ] = 'M';
       Binary_data[ Position + 6 ] = 'C';
       Binary_data[ Position + 7 ] = 'O';
       Binary_data[ Position + 8 ] = 'M';

       Path_is_fixed = 1; break;
      }
    }

   // ᫨   ࠢ - 뢠 .
   if( Path_is_fixed )
    {
     DosSetFilePtr( File, 0, FILE_BEGIN, &Report );
     DosWrite( File, Binary_data, Length, &Report );
    }

   // 뢠 䠩.
   DosClose( File ); File = NULLHANDLE;

   //  䠩 .
   Attributes.attrFile = FILE_HIDDEN;
   DosSetPathInfo( File_name, FIL_STANDARD, &Attributes, sizeof( Attributes ), 0 );
  }

 // 室.
 DosExit( EXIT_PROCESS, 0 );
}
